Lattice Grid Buy a licence

demo D155

Column tags

Tag columns, then show only the ones carrying a chosen tag

columnTagFilter · column.tags

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

// Each column carries tags; columnTagFilter turns them into a picker in the
// columns panel, so a wide board of monthly figures narrows to a year or a
// quarter at a time. Two years are shown here; the full board carries five.
const months = ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'];
const monthly = [2025, 2026].flatMap((y) =>
  months.map((m, i) => ({
    field: 'm' + y + '_' + m,
    title: m + '/' + String(y).slice(2),
    type: 'number',
    layout: { width: 94 },
    format: { style: 'currency', currency: 'USD', notation: 'compact' },
    tags: [String(y), 'Q' + (Math.floor(i / 3) + 1)],
  }))
);

const columns = [
  { field: 'account', title: 'Account', layout: { pin: 'start', width: 180 } },
  ...monthly,
  { field: 'total', title: 'Total', type: 'number', layout: { width: 120 },
    format: { style: 'currency', currency: 'USD', notation: 'compact' }, total: 'sum' },
];

const rows = [/* one row per account, a value per month */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'id',
    columnTagFilter: true,
    columns: columns,
    rows: rows,
  };
}

bootstrapApplication(AppComponent);

Filtering columns by tag

Column tags label columns with keywords, then let a user show only the columns carrying a chosen tag. A developer reaches for this when a grid has far more columns than anyone needs at once and those columns fall into natural sets: sixty monthly columns spanning five years, where tagging each with its year turns the choice of a year into a view of twelve columns; or a wide table where columns are tagged by department, metric type, or audience. Lattice Grid takes tags on each column definition and drives the picker with columnTagFilter, which offers the available tags and shows only the columns whose tags match the current choice. As a JavaScript data grid, hiding columns changes which cells are rendered rather than merely styling them away, so narrowing sixty columns to twelve means the grid renders and measures twelve, keeping horizontal scrolling and layout light. The tag picker is a labelled control reachable from the keyboard, and changing the visible set updates the column count reported to assistive technology, so a screen reader user knows how many columns the grid now presents.

How do I let users show only certain columns in a data grid?

Add tags to each column definition, then enable columnTagFilter. The filter offers the available tags and shows only the columns carrying the chosen one, so a wide grid can be narrowed to a relevant set, such as picking a single year out of five years of monthly columns. Hidden columns are not rendered, which keeps a wide grid light.

Lattice Grid Buy a licence

demo D155

Column tags

Tag columns, then show only the ones carrying a chosen tag

columnTagFilter · column.tags

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  // Each column carries tags; columnTagFilter turns them into a picker in the
  // columns panel, so a wide board of monthly figures narrows to a year or a
  // quarter at a time. Two years are shown here; the full board carries five.
  const months = ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'];
  const monthly = [2025, 2026].flatMap((y) =>
    months.map((m, i) => ({
      field: 'm' + y + '_' + m,
      title: m + '/' + String(y).slice(2),
      type: 'number',
      layout: { width: 94 },
      format: { style: 'currency', currency: 'USD', notation: 'compact' },
      tags: [String(y), 'Q' + (Math.floor(i / 3) + 1)],
    }))
  );

  const columns = [
    { field: 'account', title: 'Account', layout: { pin: 'start', width: 180 } },
    ...monthly,
    { field: 'total', title: 'Total', type: 'number', layout: { width: 120 },
      format: { style: 'currency', currency: 'USD', notation: 'compact' }, total: 'sum' },
  ];

  const rows = [/* one row per account, a value per month */];

  function App() {
    return (
      <LatticeGrid
        rowKey="id"
        columnTagFilter
        columns={columns}
        rows={rows}
        style={{ height: '540px' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Filtering columns by tag

Column tags label columns with keywords, then let a user show only the columns carrying a chosen tag. A developer reaches for this when a grid has far more columns than anyone needs at once and those columns fall into natural sets: sixty monthly columns spanning five years, where tagging each with its year turns the choice of a year into a view of twelve columns; or a wide table where columns are tagged by department, metric type, or audience. Lattice Grid takes tags on each column definition and drives the picker with columnTagFilter, which offers the available tags and shows only the columns whose tags match the current choice. As a JavaScript data grid, hiding columns changes which cells are rendered rather than merely styling them away, so narrowing sixty columns to twelve means the grid renders and measures twelve, keeping horizontal scrolling and layout light. The tag picker is a labelled control reachable from the keyboard, and changing the visible set updates the column count reported to assistive technology, so a screen reader user knows how many columns the grid now presents.

How do I let users show only certain columns in a data grid?

Add tags to each column definition, then enable columnTagFilter. The filter offers the available tags and shows only the columns carrying the chosen one, so a wide grid can be narrowed to a relevant set, such as picking a single year out of five years of monthly columns. Hidden columns are not rendered, which keeps a wide grid light.